
/*  A Bison parser, made from parse.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	EXPR_AND_AND	258
#define	EXPR_OR_OR	259
#define	EXPR_AND	260
#define	EXPR_OR	261
#define	EXPR_NOT	262
#define	EXPR_LT	263
#define	EXPR_LE	264
#define	EXPR_EQ	265
#define	EXPR_NE	266
#define	EXPR_GE	267
#define	EXPR_GT	268
#define	LEFTDIV	269
#define	EMUL	270
#define	EDIV	271
#define	ELEFTDIV	272
#define	EPLUS	273
#define	EMINUS	274
#define	QUOTE	275
#define	TRANSPOSE	276
#define	PLUS_PLUS	277
#define	MINUS_MINUS	278
#define	POW	279
#define	EPOW	280
#define	NUM	281
#define	IMAG_NUM	282
#define	NAME	283
#define	SCREW	284
#define	END	285
#define	PLOT	286
#define	TEXT	287
#define	STYLE	288
#define	FOR	289
#define	WHILE	290
#define	IF	291
#define	ELSEIF	292
#define	ELSE	293
#define	BREAK	294
#define	CONTINUE	295
#define	FUNC_RET	296
#define	UNWIND	297
#define	CLEANUP	298
#define	TRY	299
#define	CATCH	300
#define	GLOBAL	301
#define	TEXT_ID	302
#define	LEXICAL_ERROR	303
#define	FCN	304
#define	SCREW_TWO	305
#define	ELLIPSIS	306
#define	ALL_VA_ARGS	307
#define	END_OF_INPUT	308
#define	USING	309
#define	TITLE	310
#define	WITH	311
#define	COLON	312
#define	OPEN_BRACE	313
#define	CLOSE_BRACE	314
#define	CLEAR	315
#define	UNARY	316

#line 27 "parse.y"

#define YYDEBUG 1

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#ifdef YYBYACC
#include <cstdlib>
#endif

#include <strstream.h>

#include "Matrix.h"

#include "defun.h"
#include "error.h"
#include "input.h"
#include "lex.h"
#include "oct-hist.h"
#include "toplev.h"
#include "pager.h"
#include "parse.h"
#include "pt-cmd.h"
#include "pt-const.h"
#include "pt-fcn.h"
#include "pt-fvc.h"
#include "pt-mat.h"
#include "pt-mvr.h"
#include "pt-exp.h"
#include "pt-misc.h"
#include "pt-plot.h"
#include "pt-pr-code.h"
#include "symtab.h"
#include "token.h"
#include "utils.h"
#include "variables.h"

// If TRUE, generate a warning for the assignment in things like
//
//   octave> if (a = 2 < n)
//
// but not
//
//   octave> if ((a = 2) < n)
//
static bool Vwarn_assign_as_truth_value;

// If TRUE, generate a warning for the comma in things like
//
//   octave> global a, b = 2
//
static bool Vwarn_comma_in_global_decl;

// If TRUE, generate warning if declared function name disagrees with
// the name of the file in which it is defined.
static bool Vwarn_function_name_clash;

// If TRUE, generate warning if a statement in a function is not
// terminated with a semicolon.  Useful for checking functions that
// should only produce output using explicit printing statements.
static bool Vwarn_missing_semicolon;

// Temporary symbol table pointer used to cope with bogus function syntax.
symbol_table *tmp_local_sym_tab = 0;

// The current input line number.
int input_line_number = 0;

// The column of the current token.
int current_input_column = 1;

// Buffer for help text snagged from function files.
string help_buf;

// Forward declarations for some functions defined at the bottom of
// the file.

// Generic error messages.
static void yyerror (char *s);

// Error mesages for mismatched end tokens.
static void end_error (char *type, token::end_tok_type ettype, int l, int c);

// Check to see that end tokens are properly matched.
static int check_end (token *tok, token::end_tok_type expected);

// Try to figure out early if an expression should become an
// assignment to the built-in variable ans.
static tree_expression *maybe_convert_to_ans_assign (tree_expression *expr);

// Maybe print a warning if an assignment expression is used as the
// test in a logical expression.
static void maybe_warn_assign_as_truth_value (tree_expression *expr);

// Create a plot command.
static tree_plot_command *make_plot_command
	 (token *tok, plot_limits *range, subplot_list *list);

// Finish building a range.
static tree_expression *finish_colon_expression (tree_colon_expression *e);

// Build a constant.
static tree_constant *make_constant (int op, token *tok_val);

// Build a binary expression.
static tree_expression *make_binary_op
	 (int op, tree_expression *op1,	token *tok_val, tree_expression *op2);

// Build a boolean expression.
static tree_expression *make_boolean_op
	 (int op, tree_expression *op1,	token *tok_val, tree_expression *op2);

// Build a prefix expression.
static tree_expression *make_prefix_op
	 (int op, tree_identifier *op1, token *tok_val);

// Build a postfix expression.
static tree_expression *make_postfix_op
	 (int op, tree_identifier *op1, token *tok_val);

// Build a binary expression.
static tree_expression *make_unary_op
	 (int op, tree_expression *op1, token *tok_val);

// Build an unwind-protect command.
static tree_command *make_unwind_command
	 (token *unwind_tok, tree_statement_list *body,
	  tree_statement_list *cleanup, token *end_tok);

// Build a try-catch command.
static tree_command *make_try_command
	 (token *try_tok, tree_statement_list *body,
	  tree_statement_list *cleanup, token *end_tok);

// Build a while command.
static tree_command *make_while_command
	 (token *while_tok, tree_expression *expr,
	  tree_statement_list *body, token *end_tok);

// Build a for command.
static tree_command *make_for_command
	 (token *for_tok, tree_index_expression *var,
	  tree_expression *expr, tree_statement_list *body,
	  token *end_tok);

// Build a for command a different way.
static tree_command *make_for_command
	 (token *for_tok, tree_matrix_row *mr, tree_expression *expr,
	  tree_statement_list *body, token *end_tok);

// Build a break command.
static tree_command *make_break_command (token *break_tok);

// Build a continue command.
static tree_command *make_continue_command (token *continue_tok);

// Build a return command.
static tree_command *make_return_command (token *return_tok);

// Start an if command.
static tree_if_command_list *start_if_command
	 (tree_expression *expr, tree_statement_list *list);

// Finish an if command.
static tree_if_command *finish_if_command
	 (token *if_tok, tree_if_command_list *list, token *end_tok);

// Build an elseif clause.
static tree_if_clause *make_elseif_clause
	 (tree_expression *expr, tree_statement_list *list);

// Build an assignment to a variable.
static tree_expression *make_simple_assignment
	 (tree_index_expression *var, token *eq_tok, tree_expression *expr);

// Make an expression that handles assignment of multiple values.
static tree_expression *make_multi_val_ret
	 (tree_matrix_row *mr, tree_expression *rhs, token *eq_tok);

// Begin defining a function.
static tree_function *start_function_def
	 (tree_parameter_list *param_list, tree_statement_list *body);

// Do most of the work for defining a function.
static tree_function *frob_function_def
	 (tree_identifier *id, tree_function *fcn);

// Finish defining a function.
static tree_function *finish_function_def (token *var, tree_function *fcn);

// Finish defining a function a different way.
static tree_function *finish_function_def
	 (tree_parameter_list *ret_list, tree_function *fcn);

// Make an index expression.
static tree_index_expression *make_index_expression
	 (tree_indirect_ref *indir, tree_argument_list *args);

// Finish building a matrix list.
static tree_expression *finish_matrix (tree_matrix *m);

// Maybe print a warning.  Duh.
static void maybe_warn_missing_semi (tree_statement_list *);

// Set the print flag for a statement based on the separator type.
static void set_stmt_print_flag (tree_statement_list *, char, bool);

#define ABORT_PARSE \
  do \
    { \
      global_command = 0; \
      yyerrok; \
      if (interactive) \
	YYACCEPT; \
      else \
	YYABORT; \
    } \
  while (0)


#line 251 "parse.y"
typedef union
{
// The type of the basic tokens returned by the lexer.
  token *tok_val;

// Types for the nonterminals we generate.
  char sep_type;
  tree *tree_type;
  tree_matrix *tree_matrix_type;
  tree_matrix_row *tree_matrix_row_type;
  tree_expression *tree_expression_type;
  tree_constant *tree_constant_type;
  tree_identifier *tree_identifier_type;
  tree_indirect_ref *tree_indirect_ref_type;
  tree_function *tree_function_type;
  tree_index_expression *tree_index_expression_type;
  tree_colon_expression *tree_colon_expression_type;
  tree_argument_list *tree_argument_list_type;
  tree_parameter_list *tree_parameter_list_type;
  tree_command *tree_command_type;
  tree_if_command *tree_if_command_type;
  tree_if_clause *tree_if_clause_type;
  tree_if_command_list *tree_if_command_list_type;
  tree_global *tree_global_type;
  tree_global_init_list *tree_global_init_list_type;
  tree_global_command *tree_global_command_type;
  tree_statement *tree_statement_type;
  tree_statement_list *tree_statement_list_type;
  tree_plot_command *tree_plot_command_type;
  subplot *subplot_type;
  subplot_list *subplot_list_type;
  plot_limits *plot_limits_type;
  plot_range *plot_range_type;
  subplot_using *subplot_using_type;
  subplot_style *subplot_style_type;
} YYSTYPE;
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		332
#define	YYFLAG		-32768
#define	YYNTBASE	76

#define YYTRANSLATE(x) ((unsigned)(x) <= 316 ? yytranslate[x] : 142)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    69,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,    72,
    73,     7,     6,    68,     5,    75,     8,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     4,    67,     2,
     3,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
    71,     2,    74,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     9,    10,    11,
    12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
    22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
    32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
    42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
    52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
    62,    63,    64,    65,    66,    70
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     4,     7,     9,    11,    13,    16,    19,    21,
    23,    26,    28,    32,    33,    35,    38,    40,    44,    46,
    48,    51,    54,    58,    60,    63,    67,    73,    78,    83,
    87,    90,    91,    93,    97,    99,   102,   104,   106,   108,
   111,   114,   117,   120,   123,   126,   130,   134,   138,   142,
   146,   150,   152,   155,   158,   162,   165,   168,   172,   177,
   179,   182,   184,   188,   190,   194,   195,   197,   199,   201,
   203,   205,   213,   221,   227,   235,   246,   248,   250,   252,
   256,   258,   261,   265,   268,   274,   278,   279,   281,   285,
   287,   289,   291,   293,   297,   299,   301,   303,   305,   308,
   312,   315,   318,   321,   324,   327,   331,   338,   341,   344,
   347,   350,   354,   358,   362,   366,   370,   374,   378,   382,
   386,   390,   394,   398,   402,   406,   410,   414,   418,   422,
   426,   430,   434,   438,   442,   446,   449,   451,   454,   455,
   456,   457,   458,   463,   468,   474,   479,   483,   486,   490,
   493,   498,   501,   504,   508,   513,   518,   522,   524,   526,
   528,   530,   531,   536,   538,   542,   547,   550,   553,   557,
   560,   565,   568,   572,   575,   579,   581,   583,   585,   587,
   591,   595,   599,   604,   606,   609,   611,   615,   617,   620,
   622,   626,   628,   630,   633,   636,   637,   639,   641,   643,
   645,   648,   651,   654,   655
};

static const short yyrhs[] = {    77,
     0,    59,     0,    79,    78,     0,    78,     0,    69,     0,
    79,     0,    79,    69,     0,    79,    59,     0,    54,     0,
     1,     0,    80,   139,     0,    84,     0,    80,   138,    84,
     0,     0,    82,     0,    83,   141,     0,    84,     0,    83,
   140,    84,     0,   100,     0,    95,     0,    37,    66,     0,
    37,    88,     0,    37,    86,    88,     0,    87,     0,    87,
    87,     0,    87,    87,    87,     0,    64,   107,    63,   107,
    65,     0,    64,    63,   107,    65,     0,    64,   107,    63,
    65,     0,    64,    63,    65,     0,    64,    65,     0,     0,
    89,     0,    88,    68,    89,     0,   107,     0,   107,    90,
     0,    91,     0,    93,     0,    94,     0,    91,    93,     0,
    93,    91,     0,    91,    94,     0,    94,    91,     0,    93,
    94,     0,    94,    93,     0,    91,    93,    94,     0,    91,
    94,    93,     0,    93,    91,    94,     0,    93,    94,    91,
     0,    94,    91,    93,     0,    94,    93,    91,     0,    92,
     0,    92,   107,     0,    60,   107,     0,    92,    63,   107,
     0,    61,   107,     0,    62,    39,     0,    62,    39,   107,
     0,    62,    39,   107,   107,     0,   107,     0,    52,    97,
     0,    98,     0,    97,    99,    98,     0,   131,     0,   131,
     3,   107,     0,     0,    68,     0,    85,     0,   117,     0,
    96,     0,   101,     0,    48,   141,    81,    49,   141,    81,
    36,     0,    50,   141,    81,    51,   141,    81,    36,     0,
    41,   107,   141,    81,    36,     0,    40,   128,     3,   107,
   141,    81,    36,     0,    40,    71,   106,   136,    56,     3,
   107,   141,    81,    36,     0,    45,     0,    46,     0,    47,
     0,    42,   102,    36,     0,   103,     0,   103,   105,     0,
   107,   141,    81,     0,   103,   104,     0,    43,   141,   107,
   141,    81,     0,    44,   141,    81,     0,     0,   108,     0,
    32,     3,   107,     0,   109,     0,    32,     0,    33,     0,
    38,     0,    72,   108,    73,     0,   111,     0,   128,     0,
   110,     0,   133,     0,    71,    74,     0,    71,    67,    74,
     0,    28,   131,     0,    29,   131,     0,    13,   108,     0,
     6,   108,     0,     5,   108,     0,   128,     3,   108,     0,
    71,   106,   136,    56,     3,   108,     0,   131,    28,     0,
   131,    29,     0,   108,    26,     0,   108,    27,     0,   108,
    30,   108,     0,   108,    31,   108,     0,   108,     6,   108,
     0,   108,     5,   108,     0,   108,     7,   108,     0,   108,
     8,   108,     0,   108,    24,   108,     0,   108,    25,   108,
     0,   108,    21,   108,     0,   108,    22,   108,     0,   108,
    20,   108,     0,   108,    23,   108,     0,   108,    14,   108,
     0,   108,    15,   108,     0,   108,    16,   108,     0,   108,
    18,   108,     0,   108,    19,   108,     0,   108,    17,   108,
     0,   108,    11,   108,     0,   108,    12,   108,     0,   108,
     9,   108,     0,   108,    10,   108,     0,   108,     4,   108,
     0,   110,     4,   108,     0,   131,   112,     0,    38,     0,
   112,    38,     0,     0,     0,     0,     0,    55,   113,   116,
   118,     0,    55,   113,   116,   122,     0,    35,   115,   113,
     3,   122,     0,   120,   113,     3,   122,     0,    71,   115,
   114,     0,   119,    74,     0,   119,    57,    74,     0,   121,
    74,     0,   121,    68,    57,    74,     0,   119,   131,     0,
   119,     1,     0,   121,    68,   131,     0,   131,   115,   114,
   123,     0,   129,   141,    81,   124,     0,   141,    81,   124,
     0,    36,     0,    59,     0,   126,     0,   131,     0,     0,
   126,    75,   127,    53,     0,   125,     0,   125,    72,    73,
     0,   125,    72,   132,    73,     0,   125,    71,     0,    72,
    73,     0,    72,    57,    73,     0,   130,    73,     0,   130,
    68,    57,    73,     0,    72,   131,     0,   130,    68,   131,
     0,    72,     1,     0,   130,    68,     1,     0,    34,     0,
     4,     0,   107,     0,    58,     0,   132,    68,     4,     0,
   132,    68,   107,     0,   132,    68,    58,     0,    71,   106,
   134,    74,     0,   135,     0,   135,    67,     0,   136,     0,
   135,    67,   136,     0,   137,     0,   137,    68,     0,   107,
     0,   137,    68,   107,     0,    68,     0,    67,     0,   138,
    68,     0,   138,    67,     0,     0,   138,     0,    68,     0,
    67,     0,    69,     0,   140,    68,     0,   140,    67,     0,
   140,    69,     0,     0,   140,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
   374,   380,   386,   388,   392,   394,   396,   398,   402,   404,
   407,   414,   416,   424,   426,   430,   437,   442,   450,   452,
   454,   462,   467,   474,   476,   478,   482,   484,   486,   488,
   490,   494,   496,   498,   505,   507,   511,   513,   515,   517,
   519,   521,   523,   525,   527,   529,   531,   533,   535,   537,
   539,   543,   548,   555,   560,   564,   568,   570,   572,   576,
   580,   587,   589,   595,   597,   606,   607,   615,   617,   619,
   621,   626,   631,   636,   641,   646,   652,   657,   662,   669,
   676,   678,   685,   687,   694,   698,   702,   706,   708,   719,
   726,   728,   730,   732,   737,   739,   741,   743,   745,   747,
   749,   751,   753,   755,   757,   759,   761,   766,   768,   770,
   772,   774,   776,   778,   780,   782,   784,   786,   788,   790,
   792,   794,   796,   798,   800,   802,   804,   806,   808,   810,
   812,   814,   816,   820,   825,   832,   839,   844,   854,   858,
   862,   866,   870,   876,   884,   886,   890,   893,   895,   901,
   903,   910,   912,   918,   925,   932,   934,   938,   946,   953,
   959,   964,   966,   969,   971,   973,   975,   984,   989,   996,
  1002,  1011,  1013,  1018,  1024,  1032,  1039,  1045,  1047,  1053,
  1060,  1065,  1074,  1078,  1080,  1084,  1086,  1093,  1095,  1099,
  1101,  1108,  1110,  1112,  1114,  1118,  1120,  1124,  1126,  1128,
  1130,  1132,  1134,  1138,  1140
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","'='","':'",
"'-'","'+'","'*'","'/'","EXPR_AND_AND","EXPR_OR_OR","EXPR_AND","EXPR_OR","EXPR_NOT",
"EXPR_LT","EXPR_LE","EXPR_EQ","EXPR_NE","EXPR_GE","EXPR_GT","LEFTDIV","EMUL",
"EDIV","ELEFTDIV","EPLUS","EMINUS","QUOTE","TRANSPOSE","PLUS_PLUS","MINUS_MINUS",
"POW","EPOW","NUM","IMAG_NUM","NAME","SCREW","END","PLOT","TEXT","STYLE","FOR",
"WHILE","IF","ELSEIF","ELSE","BREAK","CONTINUE","FUNC_RET","UNWIND","CLEANUP",
"TRY","CATCH","GLOBAL","TEXT_ID","LEXICAL_ERROR","FCN","SCREW_TWO","ELLIPSIS",
"ALL_VA_ARGS","END_OF_INPUT","USING","TITLE","WITH","COLON","OPEN_BRACE","CLOSE_BRACE",
"CLEAR","';'","','","'\\n'","UNARY","'['","'('","')'","']'","'.'","input","input1",
"parse_error","simple_list","simple_list1","opt_list","list","list1","statement",
"plot_command","ranges","ranges1","plot_command1","plot_command2","plot_options",
"using","using1","title","style","ans_expression","global_decl","global_decl1",
"global_decl2","optcomma","command","if_command","if_cmd_list","if_cmd_list1",
"elseif_clause","else_clause","screwed_again","expression","simple_expr","simple_expr1",
"colon_expr","word_list_cmd","word_list","g_symtab","local_symtab","safe","are_we_screwed",
"func_def","func_def1","return_list_x","return_list","return_list1","func_def2",
"func_def3","fcn_end_or_eof","indirect_ref","indirect_ref1","@1","variable",
"param_list","param_list1","identifier","arg_list","matrix","rows","rows1","matrix_row",
"matrix_row1","sep_no_nl","opt_sep_no_nl","sep","opt_sep", NULL
};
#endif

static const short yyr1[] = {     0,
    76,    76,    76,    76,    77,    77,    77,    77,    78,    78,
    79,    80,    80,    81,    81,    82,    83,    83,    84,    84,
    84,    85,    85,    86,    86,    86,    87,    87,    87,    87,
    87,    88,    88,    88,    89,    89,    90,    90,    90,    90,
    90,    90,    90,    90,    90,    90,    90,    90,    90,    90,
    90,    91,    91,    92,    92,    93,    94,    94,    94,    95,
    96,    97,    97,    98,    98,    99,    99,   100,   100,   100,
   100,   100,   100,   100,   100,   100,   100,   100,   100,   101,
   102,   102,   103,   103,   104,   105,   106,   107,   107,   108,
   109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
   109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
   109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
   109,   109,   109,   109,   109,   109,   109,   109,   109,   109,
   109,   109,   109,   110,   110,   111,   112,   112,   113,   114,
   115,   116,   117,   117,   118,   118,   119,   120,   120,   120,
   120,   121,   121,   121,   122,   123,   123,   124,   124,   125,
   126,   127,   126,   128,   128,   128,   128,   129,   129,   129,
   129,   130,   130,   130,   130,   131,   132,   132,   132,   132,
   132,   132,   133,   134,   134,   135,   135,   136,   136,   137,
   137,   138,   138,   138,   138,   139,   139,   140,   140,   140,
   140,   140,   140,   141,   141
};

static const short yyr2[] = {     0,
     1,     1,     2,     1,     1,     1,     2,     2,     1,     1,
     2,     1,     3,     0,     1,     2,     1,     3,     1,     1,
     2,     2,     3,     1,     2,     3,     5,     4,     4,     3,
     2,     0,     1,     3,     1,     2,     1,     1,     1,     2,
     2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
     3,     1,     2,     2,     3,     2,     2,     3,     4,     1,
     2,     1,     3,     1,     3,     0,     1,     1,     1,     1,
     1,     7,     7,     5,     7,    10,     1,     1,     1,     3,
     1,     2,     3,     2,     5,     3,     0,     1,     3,     1,
     1,     1,     1,     3,     1,     1,     1,     1,     2,     3,
     2,     2,     2,     2,     2,     3,     6,     2,     2,     2,
     2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     2,     1,     2,     0,     0,
     0,     0,     4,     4,     5,     4,     3,     2,     3,     2,
     4,     2,     2,     3,     4,     4,     3,     1,     1,     1,
     1,     0,     4,     1,     3,     4,     2,     2,     3,     2,
     4,     2,     3,     2,     3,     1,     1,     1,     1,     3,
     3,     3,     4,     1,     2,     1,     3,     1,     2,     1,
     3,     1,     1,     2,     2,     0,     1,     1,     1,     1,
     2,     2,     2,     0,     1
};

static const short yydefact[] = {     0,
    10,     0,     0,     0,     0,     0,    91,    92,   176,    32,
    93,     0,     0,     0,    77,    78,    79,   204,   204,     0,
     9,   139,     2,     5,    87,     0,     1,     4,     0,   196,
    12,    68,    20,    70,    19,    71,    60,    88,    90,    97,
    95,    69,   164,   160,    96,   161,    98,    91,   105,   104,
   103,   101,   102,     0,     0,    21,    32,    24,    22,    33,
    35,    87,     0,   161,   204,     0,    81,   204,   199,   198,
   200,   205,    14,    14,    61,    62,    64,   142,     0,    99,
     0,     0,     8,     7,     3,   193,   192,   197,    11,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   110,   111,     0,     0,     0,   167,     0,   162,     0,   108,
   109,   137,   136,    89,     0,    31,     0,    23,    25,     0,
     0,     0,     0,    36,    37,    52,    38,    39,     0,     0,
    14,    80,   204,   204,    84,    82,    14,   202,   201,   203,
     0,    15,   204,    17,     0,    67,     0,     0,     0,   100,
   190,     0,   184,   186,   188,    94,   195,   194,    13,   134,
   115,   114,   116,   117,   132,   133,   130,   131,   124,   125,
   126,   129,   127,   128,   122,   120,   121,   123,   118,   119,
   112,   113,   135,   177,   179,   165,   178,     0,     0,   106,
   138,    30,     0,     0,    26,    34,    54,    56,    57,    40,
    42,     0,    53,    41,    44,    43,    45,     0,   204,     0,
     0,    14,    83,   204,   205,    16,   204,    63,    65,   141,
   141,   143,     0,   139,     0,   144,   141,   183,   185,     0,
   189,     0,   166,   163,    28,    29,     0,    58,    46,    47,
    55,    48,    49,    50,    51,     0,    14,    74,   204,    86,
    14,    18,    14,   139,   140,   153,     0,   148,   152,     0,
     0,   150,   140,   187,     0,   191,   180,   182,   181,    27,
    59,     0,     0,    14,     0,     0,     0,   147,   149,     0,
     0,   154,   204,   107,   204,    75,    85,    72,    73,     0,
   146,   151,     0,   155,   204,     0,    14,    14,   145,   174,
     0,   168,   172,    14,     0,   170,     0,     0,   169,     0,
   175,     0,   173,   158,   159,   157,    76,   156,   171,     0,
     0,     0
};

static const short yydefgoto[] = {   330,
    27,    28,    29,    30,   151,   152,   153,   154,    32,    57,
    58,    59,    60,   134,   135,   136,   137,   138,    33,    34,
    75,    76,   157,    35,    36,    66,    67,   145,   146,    81,
    37,    38,    39,    40,    41,   123,    78,   288,   264,   159,
    42,   232,   233,   234,   235,   236,   304,   326,    43,    44,
   199,    45,   305,   306,    46,   198,    47,   162,   163,   164,
   165,    88,    89,    72,    73
};

static const short yypact[] = {   274,
-32768,   638,   638,   638,    10,    10,    43,-32768,-32768,   511,
-32768,   -11,   656,   656,-32768,-32768,-32768,     0,     0,    10,
-32768,-32768,-32768,-32768,   -38,   638,-32768,-32768,   128,   -30,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,   725,-32768,    51,
-32768,-32768,    48,    -4,    58,     3,-32768,-32768,   119,   119,
   119,-32768,-32768,   656,   529,-32768,   656,    11,    17,-32768,
    70,-32768,    61,-32768,     0,    54,   113,     0,-32768,-32768,
-32768,    74,   481,   481,   -10,-32768,   131,-32768,    50,-32768,
   656,   343,-32768,-32768,-32768,-32768,-32768,   433,-32768,   638,
   638,   638,   638,   638,   638,   638,   638,   638,   638,   638,
   638,   638,   638,   638,   638,   638,   638,   638,   638,   638,
-32768,-32768,   638,   638,   638,-32768,   167,-32768,   638,-32768,
-32768,-32768,   115,-32768,   574,-32768,   104,    17,    11,   656,
   656,   656,   137,-32768,   101,   585,    75,   114,   656,   656,
   481,-32768,     0,     0,-32768,-32768,   481,-32768,-32768,-32768,
   130,-32768,     0,-32768,   126,-32768,    10,   656,   -15,-32768,
-32768,    96,   116,   125,   117,-32768,-32768,-32768,-32768,   808,
   138,   138,    47,    47,   753,   753,   781,   781,   675,   675,
   675,   675,   675,   675,    47,    47,    47,    47,   138,   138,
   119,   119,   808,-32768,-32768,-32768,-32768,   -16,   135,   725,
-32768,-32768,   124,   621,-32768,-32768,-32768,-32768,   656,   122,
   132,   656,-32768,   122,   143,   132,   143,   142,     0,   155,
   656,   481,-32768,     0,   385,-32768,     0,-32768,-32768,-32768,
-32768,-32768,     9,-32768,   -35,-32768,-32768,-32768,   656,   201,
   656,   371,-32768,-32768,-32768,-32768,   141,   656,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,   205,   481,-32768,     0,-32768,
   481,-32768,   481,-32768,-32768,-32768,   140,-32768,-32768,   206,
    -7,-32768,-32768,-32768,   638,-32768,-32768,-32768,-32768,-32768,
-32768,   656,   175,   481,   179,   180,   215,-32768,-32768,    10,
   145,-32768,    12,   725,     0,-32768,-32768,-32768,-32768,    10,
-32768,-32768,   121,-32768,     0,   -14,   481,   481,-32768,-32768,
   148,-32768,-32768,   481,    15,-32768,    -6,   186,-32768,    -6,
-32768,   150,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   224,
   226,-32768
};

static const short yypgoto[] = {-32768,
-32768,   198,-32768,-32768,   -71,-32768,-32768,    26,-32768,-32768,
   -47,   173,   102,-32768,  -129,-32768,   -93,  -123,-32768,-32768,
-32768,    76,-32768,-32768,-32768,-32768,-32768,-32768,-32768,   169,
     8,     2,-32768,-32768,-32768,-32768,  -217,   -39,  -197,-32768,
-32768,-32768,-32768,-32768,-32768,  -265,-32768,   -85,-32768,-32768,
-32768,   229,-32768,-32768,    -5,-32768,-32768,-32768,-32768,  -126,
-32768,-32768,-32768,    91,   -17
};


#define	YYLAST		839


static const short yytable[] = {    52,
    53,    74,   155,    49,    50,    51,    64,   214,   216,   266,
   129,   211,   218,   215,    77,   321,   270,    61,     9,   230,
    65,    68,     9,   -66,   301,    31,     9,    82,    79,   324,
   120,   121,   271,   265,   309,    80,    86,    87,   272,   273,
   122,   210,     9,     9,   217,    54,   287,   141,     9,   291,
   147,   242,   325,   315,   115,   231,   243,   156,   316,    62,
   119,   124,   127,   140,    61,   267,    69,    70,    71,   220,
   118,   322,   111,   112,    55,   223,   113,   114,    69,    70,
    71,   205,   268,   303,   130,   253,   249,   255,   161,   142,
   252,   170,   171,   172,   173,   174,   175,   176,   177,   178,
   179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
   189,   190,   274,   169,   191,   192,   193,   250,   116,   117,
   200,   310,   254,   160,   197,   221,   222,    -6,     1,   131,
   132,   133,   203,   158,   131,   226,   133,    61,   207,   208,
   148,   149,   150,   213,    93,    94,   161,   219,   113,   114,
   260,    77,   201,   237,     9,   143,   144,   105,   106,   107,
   108,   132,   133,   111,   112,   229,   204,   113,   114,   238,
   194,     2,     3,   131,   132,   209,   227,   311,   224,     4,
   240,    21,   239,   133,   241,   283,    83,   244,   245,   285,
   258,   286,   132,   312,     5,     6,    84,   256,     7,     8,
     9,   257,   131,   275,    11,   280,   261,   282,   290,   263,
   296,   247,   297,   289,   298,   299,   248,   300,   302,   251,
   319,   327,   329,   331,   195,   332,    85,   269,   259,   128,
   139,   206,   228,   293,   328,   317,   318,    25,    26,   196,
    63,   284,   320,   225,     0,     0,   161,     0,   276,   279,
   262,     0,     0,     0,     0,   281,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   292,     0,     0,     0,     0,
     0,     0,     0,     0,     1,   307,   294,   308,     2,     3,
     0,     0,     0,     0,   237,     0,     4,   314,     0,   295,
     0,     0,     0,     0,   237,     0,     0,   313,     0,     0,
     0,     5,     6,     0,     0,     7,     8,     9,     0,   323,
    10,    11,     0,    12,    13,    14,     0,     0,    15,    16,
    17,    18,     0,    19,     0,    20,     0,    21,    22,     0,
     0,     0,    23,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    24,     0,    25,    26,    90,    91,    92,    93,
    94,    95,    96,    97,    98,     0,    99,   100,   101,   102,
   103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     0,     0,   113,   114,   277,     2,     3,     0,     0,     0,
     0,     0,     0,     4,     0,     0,     0,     0,     0,     2,
     3,     0,     0,     0,     0,     0,     0,     4,     5,     6,
     0,     0,     7,     8,     9,     0,     0,     0,    11,     0,
     0,     0,     5,     6,     0,   166,     7,     8,     9,     0,
     0,    10,    11,     0,    12,    13,    14,     0,   278,    15,
    16,    17,    18,     0,    19,     0,    20,     2,     3,    22,
     0,    25,    26,     0,     0,     4,     0,     0,     0,     0,
     0,   148,   149,   150,     0,    25,    26,     0,     0,     0,
     5,     6,     0,     0,     7,     8,     9,     0,     0,    10,
    11,     0,    12,    13,    14,     0,     0,    15,    16,    17,
    18,     0,    19,     0,    20,     2,     3,    22,     0,     0,
     0,     0,     0,     4,     0,     0,     0,     0,     0,   167,
   168,     0,     0,    25,    26,     0,     0,     0,     5,     6,
     0,     0,     7,     8,     9,     2,     3,    10,    11,     0,
    12,    13,    14,     4,     0,    15,    16,    17,    18,     0,
    19,     0,    20,     2,     3,    22,     0,     0,     5,     6,
     0,     4,     7,     8,     9,     0,     0,     0,    11,     0,
     0,    25,    26,     0,     0,     0,     5,     6,     0,     0,
     7,     8,     9,     0,     0,     0,    11,     0,     0,     0,
     0,     0,     0,     0,    55,     0,    56,     0,     2,     3,
     0,    25,    26,     0,     0,     0,     4,     0,     0,     2,
     3,   125,     0,   126,     0,     0,     0,     4,     0,    25,
    26,     5,     6,     0,     0,     7,     8,     9,     0,     0,
     0,    11,     5,     6,     0,     0,     7,     8,     9,     0,
     0,     0,    11,     0,     0,     2,     3,     0,     0,     0,
     0,     0,     0,     4,     0,     0,     0,     0,   202,     0,
     0,     0,     2,     3,    25,    26,     0,   212,     5,     6,
     4,     0,     7,     8,     9,    25,    26,     0,    11,     0,
     2,     3,     0,     0,     0,     5,     6,     0,     4,    48,
     8,     9,     0,     0,     0,    11,     0,     0,    90,    91,
    92,    93,    94,     5,     6,   246,     0,     7,     8,     9,
     0,    25,    26,    11,   105,   106,   107,   108,   109,   110,
   111,   112,     0,     0,   113,   114,     0,     0,    25,    26,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    25,    26,    90,    91,
    92,    93,    94,    95,    96,    97,    98,     0,    99,   100,
   101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
   111,   112,     0,     0,   113,   114,    90,    91,    92,    93,
    94,     0,     0,    97,    98,     0,    99,   100,   101,   102,
   103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     0,     0,   113,   114,    90,    91,    92,    93,    94,     0,
     0,     0,     0,     0,    99,   100,   101,   102,   103,   104,
   105,   106,   107,   108,   109,   110,   111,   112,     0,     0,
   113,   114,    91,    92,    93,    94,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   105,   106,   107,
   108,   109,   110,   111,   112,     0,     0,   113,   114
};

static const short yycheck[] = {     5,
     6,    19,    74,     2,     3,     4,    12,   137,   138,     1,
    58,   135,   139,   137,    20,     1,   234,    10,    34,    35,
    13,    14,    34,    34,   290,     0,    34,    26,    67,    36,
    28,    29,    68,   231,   300,    74,    67,    68,    74,   237,
    38,   135,    34,    34,   138,     3,   264,    65,    34,    57,
    68,    68,    59,    68,     4,    71,    73,    68,    73,    71,
     3,    54,    55,     3,    57,    57,    67,    68,    69,   141,
    75,    57,    26,    27,    64,   147,    30,    31,    67,    68,
    69,   129,    74,    72,    68,   215,   210,   217,    81,    36,
   214,    90,    91,    92,    93,    94,    95,    96,    97,    98,
    99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
   109,   110,   239,    88,   113,   114,   115,   211,    71,    72,
   119,     1,   216,    74,   117,   143,   144,     0,     1,    60,
    61,    62,   125,     3,    60,   153,    62,   130,   131,   132,
    67,    68,    69,   136,     7,     8,   139,   140,    30,    31,
   222,   157,    38,   159,    34,    43,    44,    20,    21,    22,
    23,    61,    62,    26,    27,   158,    63,    30,    31,    74,
     4,     5,     6,    60,    61,    39,    51,    57,    49,    13,
    56,    54,    67,    62,    68,   257,    59,    53,    65,   261,
    36,   263,    61,    73,    28,    29,    69,    56,    32,    33,
    34,   219,    60,     3,    38,    65,   224,     3,     3,   227,
    36,   204,   284,    74,    36,    36,   209,     3,    74,   212,
    73,    36,    73,     0,    58,     0,    29,   233,   221,    57,
    62,   130,   157,   273,   320,   307,   308,    71,    72,    73,
    12,   259,   314,   153,    -1,    -1,   239,    -1,   241,   242,
   225,    -1,    -1,    -1,    -1,   248,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,   271,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,     1,   293,   275,   295,     5,     6,
    -1,    -1,    -1,    -1,   290,    -1,    13,   305,    -1,   282,
    -1,    -1,    -1,    -1,   300,    -1,    -1,   303,    -1,    -1,
    -1,    28,    29,    -1,    -1,    32,    33,    34,    -1,   315,
    37,    38,    -1,    40,    41,    42,    -1,    -1,    45,    46,
    47,    48,    -1,    50,    -1,    52,    -1,    54,    55,    -1,
    -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    69,    -1,    71,    72,     4,     5,     6,     7,
     8,     9,    10,    11,    12,    -1,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    -1,    -1,    30,    31,     4,     5,     6,    -1,    -1,    -1,
    -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,     5,
     6,    -1,    -1,    -1,    -1,    -1,    -1,    13,    28,    29,
    -1,    -1,    32,    33,    34,    -1,    -1,    -1,    38,    -1,
    -1,    -1,    28,    29,    -1,    73,    32,    33,    34,    -1,
    -1,    37,    38,    -1,    40,    41,    42,    -1,    58,    45,
    46,    47,    48,    -1,    50,    -1,    52,     5,     6,    55,
    -1,    71,    72,    -1,    -1,    13,    -1,    -1,    -1,    -1,
    -1,    67,    68,    69,    -1,    71,    72,    -1,    -1,    -1,
    28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,    37,
    38,    -1,    40,    41,    42,    -1,    -1,    45,    46,    47,
    48,    -1,    50,    -1,    52,     5,     6,    55,    -1,    -1,
    -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,    -1,    67,
    68,    -1,    -1,    71,    72,    -1,    -1,    -1,    28,    29,
    -1,    -1,    32,    33,    34,     5,     6,    37,    38,    -1,
    40,    41,    42,    13,    -1,    45,    46,    47,    48,    -1,
    50,    -1,    52,     5,     6,    55,    -1,    -1,    28,    29,
    -1,    13,    32,    33,    34,    -1,    -1,    -1,    38,    -1,
    -1,    71,    72,    -1,    -1,    -1,    28,    29,    -1,    -1,
    32,    33,    34,    -1,    -1,    -1,    38,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    64,    -1,    66,    -1,     5,     6,
    -1,    71,    72,    -1,    -1,    -1,    13,    -1,    -1,     5,
     6,    63,    -1,    65,    -1,    -1,    -1,    13,    -1,    71,
    72,    28,    29,    -1,    -1,    32,    33,    34,    -1,    -1,
    -1,    38,    28,    29,    -1,    -1,    32,    33,    34,    -1,
    -1,    -1,    38,    -1,    -1,     5,     6,    -1,    -1,    -1,
    -1,    -1,    -1,    13,    -1,    -1,    -1,    -1,    65,    -1,
    -1,    -1,     5,     6,    71,    72,    -1,    63,    28,    29,
    13,    -1,    32,    33,    34,    71,    72,    -1,    38,    -1,
     5,     6,    -1,    -1,    -1,    28,    29,    -1,    13,    32,
    33,    34,    -1,    -1,    -1,    38,    -1,    -1,     4,     5,
     6,     7,     8,    28,    29,    65,    -1,    32,    33,    34,
    -1,    71,    72,    38,    20,    21,    22,    23,    24,    25,
    26,    27,    -1,    -1,    30,    31,    -1,    -1,    71,    72,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    71,    72,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    -1,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    -1,    -1,    30,    31,     4,     5,     6,     7,
     8,    -1,    -1,    11,    12,    -1,    14,    15,    16,    17,
    18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
    -1,    -1,    30,    31,     4,     5,     6,     7,     8,    -1,
    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
    20,    21,    22,    23,    24,    25,    26,    27,    -1,    -1,
    30,    31,     5,     6,     7,     8,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    21,    22,
    23,    24,    25,    26,    27,    -1,    -1,    30,    31
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/local/share/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 1:
#line 375 "parse.y"
{
		    global_command = yyvsp[0].tree_statement_list_type;
		    promptflag = 1;
		    YYACCEPT;
		  ;
    break;}
case 2:
#line 381 "parse.y"
{
		    global_command = 0;
		    promptflag = 1;
		    YYABORT;
		  ;
    break;}
case 3:
#line 387 "parse.y"
{ ABORT_PARSE; ;
    break;}
case 4:
#line 389 "parse.y"
{ ABORT_PARSE; ;
    break;}
case 5:
#line 393 "parse.y"
{ yyval.tree_statement_list_type = 0; ;
    break;}
case 6:
#line 395 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[0].tree_statement_list_type; ;
    break;}
case 7:
#line 397 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type; ;
    break;}
case 8:
#line 399 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type; ;
    break;}
case 9:
#line 403 "parse.y"
{ yyerror ("parse error"); ;
    break;}
case 11:
#line 408 "parse.y"
{
		    set_stmt_print_flag (yyvsp[-1].tree_statement_list_type, yyvsp[0].sep_type, false);
		    yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type;
		  ;
    break;}
case 12:
#line 415 "parse.y"
{ yyval.tree_statement_list_type = new tree_statement_list (yyvsp[0].tree_statement_type); ;
    break;}
case 13:
#line 417 "parse.y"
{
		    set_stmt_print_flag (yyvsp[-2].tree_statement_list_type, yyvsp[-1].sep_type, false);
		    yyvsp[-2].tree_statement_list_type->append (yyvsp[0].tree_statement_type);
		    yyval.tree_statement_list_type = yyvsp[-2].tree_statement_list_type;
		  ;
    break;}
case 14:
#line 425 "parse.y"
{ yyval.tree_statement_list_type = new tree_statement_list (); ;
    break;}
case 15:
#line 427 "parse.y"
{ yyval.tree_statement_list_type = yyvsp[0].tree_statement_list_type; ;
    break;}
case 16:
#line 431 "parse.y"
{
		    set_stmt_print_flag (yyvsp[-1].tree_statement_list_type, yyvsp[0].sep_type, true);
		    yyval.tree_statement_list_type = yyvsp[-1].tree_statement_list_type;
		  ;
    break;}
case 17:
#line 438 "parse.y"
{
		    lexer_flags.beginning_of_function = 0;
		    yyval.tree_statement_list_type = new tree_statement_list (yyvsp[0].tree_statement_type);
		  ;
    break;}
case 18:
#line 443 "parse.y"
{
		    set_stmt_print_flag (yyvsp[-2].tree_statement_list_type, yyvsp[-1].sep_type, true);
		    yyvsp[-2].tree_statement_list_type->append (yyvsp[0].tree_statement_type);
		    yyval.tree_statement_list_type = yyvsp[-2].tree_statement_list_type;
		  ;
    break;}
case 19:
#line 451 "parse.y"
{ yyval.tree_statement_type = new tree_statement (yyvsp[0].tree_command_type); ;
    break;}
case 20:
#line 453 "parse.y"
{ yyval.tree_statement_type = new tree_statement (yyvsp[0].tree_expression_type); ;
    break;}
case 21:
#line 455 "parse.y"
{
		    symbol_record *sr = lookup_by_name ("clearplot", 0);
		    tree_identifier *id = new tree_identifier (sr);
		    yyval.tree_statement_type = new tree_statement (id);
		  ;
    break;}
case 22:
#line 463 "parse.y"
{
		    if (! (yyval.tree_plot_command_type = make_plot_command (yyvsp[-1].tok_val, 0, yyvsp[0].subplot_list_type)))
		      ABORT_PARSE;
		  ;
    break;}
case 23:
#line 468 "parse.y"
{
		    if (! (yyval.tree_plot_command_type = make_plot_command (yyvsp[-2].tok_val, yyvsp[-1].plot_limits_type, yyvsp[0].subplot_list_type)))
		      ABORT_PARSE;
		  ;
    break;}
case 24:
#line 475 "parse.y"
{ yyval.plot_limits_type = new plot_limits (yyvsp[0].plot_range_type); ;
    break;}
case 25:
#line 477 "parse.y"
{ yyval.plot_limits_type = new plot_limits (yyvsp[-1].plot_range_type, yyvsp[0].plot_range_type); ;
    break;}
case 26:
#line 479 "parse.y"
{ yyval.plot_limits_type = new plot_limits (yyvsp[-2].plot_range_type, yyvsp[-1].plot_range_type, yyvsp[0].plot_range_type); ;
    break;}
case 27:
#line 483 "parse.y"
{ yyval.plot_range_type = new plot_range (yyvsp[-3].tree_expression_type, yyvsp[-1].tree_expression_type); ;
    break;}
case 28:
#line 485 "parse.y"
{ yyval.plot_range_type = new plot_range (0, yyvsp[-1].tree_expression_type); ;
    break;}
case 29:
#line 487 "parse.y"
{ yyval.plot_range_type = new plot_range (yyvsp[-2].tree_expression_type, 0); ;
    break;}
case 30:
#line 489 "parse.y"
{ yyval.plot_range_type = new plot_range (); ;
    break;}
case 31:
#line 491 "parse.y"
{ yyval.plot_range_type = new plot_range (); ;
    break;}
case 32:
#line 495 "parse.y"
{ yyval.subplot_list_type = 0; ;
    break;}
case 33:
#line 497 "parse.y"
{ yyval.subplot_list_type = new subplot_list (yyvsp[0].subplot_type); ;
    break;}
case 34:
#line 499 "parse.y"
{
		    yyvsp[-2].subplot_list_type->append (yyvsp[0].subplot_type);
		    yyval.subplot_list_type = yyvsp[-2].subplot_list_type;
		  ;
    break;}
case 35:
#line 506 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].tree_expression_type); ;
    break;}
case 36:
#line 508 "parse.y"
{ yyval.subplot_type = yyvsp[0].subplot_type->set_data (yyvsp[-1].tree_expression_type); ;
    break;}
case 37:
#line 512 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, 0, 0); ;
    break;}
case 38:
#line 514 "parse.y"
{ yyval.subplot_type = new subplot (0, yyvsp[0].tree_expression_type, 0); ;
    break;}
case 39:
#line 516 "parse.y"
{ yyval.subplot_type = new subplot (0, 0, yyvsp[0].subplot_style_type); ;
    break;}
case 40:
#line 518 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-1].subplot_using_type, yyvsp[0].tree_expression_type, 0); ;
    break;}
case 41:
#line 520 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, yyvsp[-1].tree_expression_type, 0); ;
    break;}
case 42:
#line 522 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-1].subplot_using_type, 0, yyvsp[0].subplot_style_type); ;
    break;}
case 43:
#line 524 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, 0, yyvsp[-1].subplot_style_type); ;
    break;}
case 44:
#line 526 "parse.y"
{ yyval.subplot_type = new subplot (0, yyvsp[-1].tree_expression_type, yyvsp[0].subplot_style_type); ;
    break;}
case 45:
#line 528 "parse.y"
{ yyval.subplot_type = new subplot (0, yyvsp[0].tree_expression_type, yyvsp[-1].subplot_style_type); ;
    break;}
case 46:
#line 530 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-2].subplot_using_type, yyvsp[-1].tree_expression_type, yyvsp[0].subplot_style_type); ;
    break;}
case 47:
#line 532 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-2].subplot_using_type, yyvsp[0].tree_expression_type, yyvsp[-1].subplot_style_type); ;
    break;}
case 48:
#line 534 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-1].subplot_using_type, yyvsp[-2].tree_expression_type, yyvsp[0].subplot_style_type); ;
    break;}
case 49:
#line 536 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, yyvsp[-2].tree_expression_type, yyvsp[-1].subplot_style_type); ;
    break;}
case 50:
#line 538 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[-1].subplot_using_type, yyvsp[0].tree_expression_type, yyvsp[-2].subplot_style_type); ;
    break;}
case 51:
#line 540 "parse.y"
{ yyval.subplot_type = new subplot (yyvsp[0].subplot_using_type, yyvsp[-1].tree_expression_type, yyvsp[-2].subplot_style_type); ;
    break;}
case 52:
#line 544 "parse.y"
{
		    lexer_flags.in_plot_using = 0;
		    yyval.subplot_using_type = yyvsp[0].subplot_using_type;
		  ;
    break;}
case 53:
#line 549 "parse.y"
{
		    lexer_flags.in_plot_using = 0;
		    yyval.subplot_using_type = yyvsp[-1].subplot_using_type->set_format (yyvsp[0].tree_expression_type);
		  ;
    break;}
case 54:
#line 556 "parse.y"
{
		    subplot_using *tmp = new subplot_using ();
		    yyval.subplot_using_type = tmp->add_qualifier (yyvsp[0].tree_expression_type);
		  ;
    break;}
case 55:
#line 561 "parse.y"
{ yyval.subplot_using_type = yyvsp[-2].subplot_using_type->add_qualifier (yyvsp[0].tree_expression_type); ;
    break;}
case 56:
#line 565 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_expression_type; ;
    break;}
case 57:
#line 569 "parse.y"
{ yyval.subplot_style_type = new subplot_style (yyvsp[0].tok_val->text ()); ;
    break;}
case 58:
#line 571 "parse.y"
{ yyval.subplot_style_type = new subplot_style (yyvsp[-1].tok_val->text (), yyvsp[0].tree_expression_type); ;
    break;}
case 59:
#line 573 "parse.y"
{ yyval.subplot_style_type = new subplot_style (yyvsp[-2].tok_val->text (), yyvsp[-1].tree_expression_type, yyvsp[0].tree_expression_type); ;
    break;}
case 60:
#line 577 "parse.y"
{ yyval.tree_expression_type = maybe_convert_to_ans_assign (yyvsp[0].tree_expression_type); ;
    break;}
case 61:
#line 581 "parse.y"
{
		    yyval.tree_global_command_type = new tree_global_command (yyvsp[0].tree_global_init_list_type, yyvsp[-1].tok_val->line (),
						  yyvsp[-1].tok_val->column ());
		  ;
    break;}
case 62:
#line 588 "parse.y"
{ yyval.tree_global_init_list_type = new tree_global_init_list (yyvsp[0].tree_global_type); ;
    break;}
case 63:
#line 590 "parse.y"
{
		    yyvsp[-2].tree_global_init_list_type->append (yyvsp[0].tree_global_type);
		    yyval.tree_global_init_list_type = yyvsp[-2].tree_global_init_list_type;
		  ;
    break;}
case 64:
#line 596 "parse.y"
{ yyval.tree_global_type = new tree_global (yyvsp[0].tree_identifier_type); ;
    break;}
case 65:
#line 598 "parse.y"
{
		    tree_simple_assignment_expression *tmp_ass;
		    tmp_ass = new tree_simple_assignment_expression
		      (yyvsp[-2].tree_identifier_type, yyvsp[0].tree_expression_type, 0, 0, yyvsp[-1].tok_val->line (), yyvsp[-1].tok_val->column ());
		    yyval.tree_global_type = new tree_global (tmp_ass);
		  ;
    break;}
case 67:
#line 608 "parse.y"
{
		    if (Vwarn_comma_in_global_decl)
		      warning ("comma in global declaration not\
 interpreted as a command separator");
		  ;
    break;}
case 68:
#line 616 "parse.y"
{ yyval.tree_command_type = yyvsp[0].tree_plot_command_type; ;
    break;}
case 69:
#line 618 "parse.y"
{ yyval.tree_command_type = yyvsp[0].tree_command_type; ;
    break;}
case 70:
#line 620 "parse.y"
{ yyval.tree_command_type = yyvsp[0].tree_global_command_type; ;
    break;}
case 71:
#line 622 "parse.y"
{
		    lexer_flags.iffing--;
		    yyval.tree_command_type = yyvsp[0].tree_if_command_type;
		  ;
    break;}
case 72:
#line 627 "parse.y"
{
		    if (! (yyval.tree_command_type = make_unwind_command (yyvsp[-6].tok_val, yyvsp[-4].tree_statement_list_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 73:
#line 632 "parse.y"
{
		    if (! (yyval.tree_command_type = make_try_command (yyvsp[-6].tok_val, yyvsp[-4].tree_statement_list_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 74:
#line 637 "parse.y"
{
		    if (! (yyval.tree_command_type = make_while_command (yyvsp[-4].tok_val, yyvsp[-3].tree_expression_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 75:
#line 642 "parse.y"
{
		    if (! (yyval.tree_command_type = make_for_command (yyvsp[-6].tok_val, yyvsp[-5].tree_index_expression_type, yyvsp[-3].tree_expression_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 76:
#line 648 "parse.y"
{
		    if (! (yyval.tree_command_type = make_for_command (yyvsp[-9].tok_val, yyvsp[-6].tree_matrix_row_type, yyvsp[-3].tree_expression_type, yyvsp[-1].tree_statement_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 77:
#line 653 "parse.y"
{
		    if (! (yyval.tree_command_type = make_break_command (yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 78:
#line 658 "parse.y"
{
		    if (! (yyval.tree_command_type = make_continue_command (yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 79:
#line 663 "parse.y"
{
		    if (! (yyval.tree_command_type = make_return_command (yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 80:
#line 670 "parse.y"
{
		    if (! (yyval.tree_if_command_type = finish_if_command (yyvsp[-2].tok_val, yyvsp[-1].tree_if_command_list_type, yyvsp[0].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 81:
#line 677 "parse.y"
{ yyval.tree_if_command_list_type = yyvsp[0].tree_if_command_list_type; ;
    break;}
case 82:
#line 679 "parse.y"
{
		    yyvsp[-1].tree_if_command_list_type->append (yyvsp[0].tree_if_clause_type);
		    yyval.tree_if_command_list_type = yyvsp[-1].tree_if_command_list_type;
		  ;
    break;}
case 83:
#line 686 "parse.y"
{ yyval.tree_if_command_list_type = start_if_command (yyvsp[-2].tree_expression_type, yyvsp[0].tree_statement_list_type); ;
    break;}
case 84:
#line 688 "parse.y"
{
		    yyvsp[-1].tree_if_command_list_type->append (yyvsp[0].tree_if_clause_type);
		    yyval.tree_if_command_list_type = yyvsp[-1].tree_if_command_list_type;
		  ;
    break;}
case 85:
#line 695 "parse.y"
{ yyval.tree_if_clause_type = make_elseif_clause (yyvsp[-2].tree_expression_type, yyvsp[0].tree_statement_list_type); ;
    break;}
case 86:
#line 699 "parse.y"
{ yyval.tree_if_clause_type = new tree_if_clause (yyvsp[0].tree_statement_list_type); ;
    break;}
case 87:
#line 703 "parse.y"
{ lexer_flags.maybe_screwed_again++; ;
    break;}
case 88:
#line 707 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_expression_type; ;
    break;}
case 89:
#line 709 "parse.y"
{
		    yyerror ("invalid assignment to a number");
		    yyval.tree_expression_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 90:
#line 720 "parse.y"
{
		    if (! (yyval.tree_expression_type = yyvsp[0].tree_expression_type))
		      ABORT_PARSE;
		  ;
    break;}
case 91:
#line 727 "parse.y"
{ yyval.tree_expression_type = make_constant (NUM, yyvsp[0].tok_val); ;
    break;}
case 92:
#line 729 "parse.y"
{ yyval.tree_expression_type = make_constant (IMAG_NUM, yyvsp[0].tok_val); ;
    break;}
case 93:
#line 731 "parse.y"
{ yyval.tree_expression_type = make_constant (TEXT, yyvsp[0].tok_val); ;
    break;}
case 94:
#line 733 "parse.y"
{
		    yyvsp[-1].tree_expression_type->mark_in_parens ();
		    yyval.tree_expression_type = yyvsp[-1].tree_expression_type;
		  ;
    break;}
case 95:
#line 738 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_index_expression_type; ;
    break;}
case 96:
#line 740 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_index_expression_type; ;
    break;}
case 97:
#line 742 "parse.y"
{ yyval.tree_expression_type = finish_colon_expression (yyvsp[0].tree_colon_expression_type); ;
    break;}
case 98:
#line 744 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_expression_type; ;
    break;}
case 99:
#line 746 "parse.y"
{ yyval.tree_expression_type = new tree_constant (Matrix ()); ;
    break;}
case 100:
#line 748 "parse.y"
{ yyval.tree_expression_type = new tree_constant (Matrix ()); ;
    break;}
case 101:
#line 750 "parse.y"
{ yyval.tree_expression_type = make_prefix_op (PLUS_PLUS, yyvsp[0].tree_identifier_type, yyvsp[-1].tok_val); ;
    break;}
case 102:
#line 752 "parse.y"
{ yyval.tree_expression_type = make_prefix_op (MINUS_MINUS, yyvsp[0].tree_identifier_type, yyvsp[-1].tok_val); ;
    break;}
case 103:
#line 754 "parse.y"
{ yyval.tree_expression_type = make_unary_op (EXPR_NOT, yyvsp[0].tree_expression_type, yyvsp[-1].tok_val); ;
    break;}
case 104:
#line 756 "parse.y"
{ yyval.tree_expression_type = yyvsp[0].tree_expression_type; ;
    break;}
case 105:
#line 758 "parse.y"
{ yyval.tree_expression_type = make_unary_op ('-', yyvsp[0].tree_expression_type, yyvsp[-1].tok_val); ;
    break;}
case 106:
#line 760 "parse.y"
{ yyval.tree_expression_type = make_simple_assignment (yyvsp[-2].tree_index_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 107:
#line 762 "parse.y"
{
		    if (! (yyval.tree_expression_type = make_multi_val_ret (yyvsp[-3].tree_matrix_row_type, yyvsp[0].tree_expression_type, yyvsp[-1].tok_val)))
		      ABORT_PARSE;
		  ;
    break;}
case 108:
#line 767 "parse.y"
{ yyval.tree_expression_type = make_postfix_op (PLUS_PLUS, yyvsp[-1].tree_identifier_type, yyvsp[0].tok_val); ;
    break;}
case 109:
#line 769 "parse.y"
{ yyval.tree_expression_type = make_postfix_op (MINUS_MINUS, yyvsp[-1].tree_identifier_type, yyvsp[0].tok_val); ;
    break;}
case 110:
#line 771 "parse.y"
{ yyval.tree_expression_type = make_unary_op (QUOTE, yyvsp[-1].tree_expression_type, yyvsp[0].tok_val); ;
    break;}
case 111:
#line 773 "parse.y"
{ yyval.tree_expression_type = make_unary_op (TRANSPOSE, yyvsp[-1].tree_expression_type, yyvsp[0].tok_val); ;
    break;}
case 112:
#line 775 "parse.y"
{ yyval.tree_expression_type = make_binary_op (POW, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 113:
#line 777 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EPOW, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 114:
#line 779 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('+', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 115:
#line 781 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('-', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 116:
#line 783 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('*', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 117:
#line 785 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('/', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 118:
#line 787 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('+', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 119:
#line 789 "parse.y"
{ yyval.tree_expression_type = make_binary_op ('-', yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 120:
#line 791 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EMUL, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 121:
#line 793 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EDIV, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 122:
#line 795 "parse.y"
{ yyval.tree_expression_type = make_binary_op (LEFTDIV, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 123:
#line 797 "parse.y"
{ yyval.tree_expression_type = make_binary_op (ELEFTDIV, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 124:
#line 799 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_LT, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 125:
#line 801 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_LE, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 126:
#line 803 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_EQ, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 127:
#line 805 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_GE, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 128:
#line 807 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_GT, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 129:
#line 809 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_NE, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 130:
#line 811 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_AND, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 131:
#line 813 "parse.y"
{ yyval.tree_expression_type = make_binary_op (EXPR_OR, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 132:
#line 815 "parse.y"
{ yyval.tree_expression_type = make_boolean_op (EXPR_AND_AND, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 133:
#line 817 "parse.y"
{ yyval.tree_expression_type = make_boolean_op (EXPR_OR_OR, yyvsp[-2].tree_expression_type, yyvsp[-1].tok_val, yyvsp[0].tree_expression_type); ;
    break;}
case 134:
#line 821 "parse.y"
{
		    yyval.tree_colon_expression_type = new tree_colon_expression
		      (yyvsp[-2].tree_expression_type, yyvsp[0].tree_expression_type, yyvsp[-1].tok_val->line (), yyvsp[-1].tok_val->column ());
		  ;
    break;}
case 135:
#line 826 "parse.y"
{
		    if (! (yyval.tree_colon_expression_type = yyvsp[-2].tree_colon_expression_type->chain (yyvsp[0].tree_expression_type)))
		      ABORT_PARSE;
		  ;
    break;}
case 136:
#line 833 "parse.y"
{
		    yyval.tree_index_expression_type = new tree_index_expression
		      (yyvsp[-1].tree_identifier_type, yyvsp[0].tree_argument_list_type, yyvsp[-1].tree_identifier_type->line (), yyvsp[-1].tree_identifier_type->column ());
		  ;
    break;}
case 137:
#line 840 "parse.y"
{
		    tree_constant *tmp = make_constant (TEXT, yyvsp[0].tok_val);
		    yyval.tree_argument_list_type = new tree_argument_list (tmp);
		  ;
    break;}
case 138:
#line 845 "parse.y"
{
		    tree_constant *tmp = make_constant (TEXT, yyvsp[0].tok_val);
		    yyvsp[-1].tree_argument_list_type->append (tmp);
		    yyval.tree_argument_list_type = yyvsp[-1].tree_argument_list_type;
		  ;
    break;}
case 139:
#line 855 "parse.y"
{ curr_sym_tab = global_sym_tab; ;
    break;}
case 140:
#line 859 "parse.y"
{ curr_sym_tab = tmp_local_sym_tab; ;
    break;}
case 141:
#line 863 "parse.y"
{ lexer_flags.maybe_screwed = 0; ;
    break;}
case 142:
#line 867 "parse.y"
{ lexer_flags.maybe_screwed = 1; ;
    break;}
case 143:
#line 871 "parse.y"
{
		    curr_sym_tab = top_level_sym_tab;
		    lexer_flags.defining_func = 0;
		    yyval.tree_command_type = 0;
		  ;
    break;}
case 144:
#line 877 "parse.y"
{
		    curr_sym_tab = top_level_sym_tab;
		    lexer_flags.defining_func = 0;
		    yyval.tree_command_type = 0;
		  ;
    break;}
case 145:
#line 885 "parse.y"
{ yyval.tree_function_type = finish_function_def (yyvsp[-4].tok_val, yyvsp[0].tree_function_type); ;
    break;}
case 146:
#line 887 "parse.y"
{ yyval.tree_function_type = finish_function_def (yyvsp[-3].tree_parameter_list_type, yyvsp[0].tree_function_type); ;
    break;}
case 148:
#line 894 "parse.y"
{ yyval.tree_parameter_list_type = new tree_parameter_list (); ;
    break;}
case 149:
#line 896 "parse.y"
{
		    tree_parameter_list *tmp = new tree_parameter_list ();
		    tmp->mark_varargs_only ();
		    yyval.tree_parameter_list_type = tmp;
		  ;
    break;}
case 150:
#line 902 "parse.y"
{ yyval.tree_parameter_list_type = yyvsp[-1].tree_parameter_list_type; ;
    break;}
case 151:
#line 904 "parse.y"
{
		    yyvsp[-3].tree_parameter_list_type->mark_varargs ();
		    yyval.tree_parameter_list_type = yyvsp[-3].tree_parameter_list_type;
		  ;
    break;}
case 152:
#line 911 "parse.y"
{ yyval.tree_parameter_list_type = new tree_parameter_list (yyvsp[0].tree_identifier_type); ;
    break;}
case 153:
#line 913 "parse.y"
{
		    yyerror ("invalid function return list");
		    yyval.tree_parameter_list_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 154:
#line 919 "parse.y"
{
		    yyvsp[-2].tree_parameter_list_type->append (yyvsp[0].tree_identifier_type);
		    yyval.tree_parameter_list_type = yyvsp[-2].tree_parameter_list_type;
		  ;
    break;}
case 155:
#line 926 "parse.y"
{
		    if (! (yyval.tree_function_type = frob_function_def (yyvsp[-3].tree_identifier_type, yyvsp[0].tree_function_type)))
		      ABORT_PARSE;
		  ;
    break;}
case 156:
#line 933 "parse.y"
{ yyval.tree_function_type = start_function_def (yyvsp[-3].tree_parameter_list_type, yyvsp[-1].tree_statement_list_type); ;
    break;}
case 157:
#line 935 "parse.y"
{ yyval.tree_function_type = start_function_def (0, yyvsp[-1].tree_statement_list_type); ;
    break;}
case 158:
#line 939 "parse.y"
{
		    if (check_end (yyvsp[0].tok_val, token::function_end))
		      ABORT_PARSE;

		    if (reading_fcn_file)
		      check_for_garbage_after_fcn_def ();
		  ;
    break;}
case 159:
#line 947 "parse.y"
{
		    if (! (reading_fcn_file || reading_script_file))
		      YYABORT;
		  ;
    break;}
case 160:
#line 954 "parse.y"
{
		    lexer_flags.looking_at_indirect_ref = 0;
		    yyval.tree_indirect_ref_type = yyvsp[0].tree_indirect_ref_type;
		  ;
    break;}
case 161:
#line 960 "parse.y"
{
		    yyval.tree_indirect_ref_type = new tree_indirect_ref (yyvsp[0].tree_identifier_type, yyvsp[0].tree_identifier_type->line (),
						yyvsp[0].tree_identifier_type->column ());
		  ;
    break;}
case 162:
#line 965 "parse.y"
{ lexer_flags.looking_at_indirect_ref = 1; ;
    break;}
case 163:
#line 966 "parse.y"
{ yyval.tree_indirect_ref_type = new tree_indirect_ref (yyvsp[-3].tree_indirect_ref_type, yyvsp[0].tok_val->text ()); ;
    break;}
case 164:
#line 970 "parse.y"
{ yyval.tree_index_expression_type = make_index_expression (yyvsp[0].tree_indirect_ref_type, 0); ;
    break;}
case 165:
#line 972 "parse.y"
{ yyval.tree_index_expression_type = make_index_expression (yyvsp[-2].tree_indirect_ref_type, 0); ;
    break;}
case 166:
#line 974 "parse.y"
{ yyval.tree_index_expression_type = make_index_expression (yyvsp[-3].tree_indirect_ref_type, yyvsp[-1].tree_argument_list_type); ;
    break;}
case 167:
#line 976 "parse.y"
{
		    yyerror ("use `(\' and `)\' as index operators, not\
 `[\' and `]\'"); 
		    yyval.tree_index_expression_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 168:
#line 985 "parse.y"
{
		    lexer_flags.quote_is_transpose = 0;
		    yyval.tree_parameter_list_type = 0;
		  ;
    break;}
case 169:
#line 990 "parse.y"
{
		    lexer_flags.quote_is_transpose = 0;
		    tree_parameter_list *tmp = new tree_parameter_list ();
		    tmp->mark_varargs_only ();
		    yyval.tree_parameter_list_type = tmp;
		  ;
    break;}
case 170:
#line 997 "parse.y"
{
		    lexer_flags.quote_is_transpose = 0;
		    yyvsp[-1].tree_parameter_list_type->mark_as_formal_parameters ();
		    yyval.tree_parameter_list_type = yyvsp[-1].tree_parameter_list_type;
		  ;
    break;}
case 171:
#line 1003 "parse.y"
{
		    lexer_flags.quote_is_transpose = 0;
		    yyvsp[-3].tree_parameter_list_type->mark_as_formal_parameters ();
		    yyvsp[-3].tree_parameter_list_type->mark_varargs ();
		    yyval.tree_parameter_list_type = yyvsp[-3].tree_parameter_list_type;
		  ;
    break;}
case 172:
#line 1012 "parse.y"
{ yyval.tree_parameter_list_type = new tree_parameter_list (yyvsp[0].tree_identifier_type); ;
    break;}
case 173:
#line 1014 "parse.y"
{
		    yyvsp[-2].tree_parameter_list_type->append (yyvsp[0].tree_identifier_type);
		    yyval.tree_parameter_list_type = yyvsp[-2].tree_parameter_list_type;
		  ;
    break;}
case 174:
#line 1019 "parse.y"
{
		    yyerror ("invalid parameter list");
		    yyval.tree_parameter_list_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 175:
#line 1025 "parse.y"
{
		    yyerror ("invalid parameter list");
		    yyval.tree_parameter_list_type = 0;
		    ABORT_PARSE;
		  ;
    break;}
case 176:
#line 1033 "parse.y"
{
		    yyval.tree_identifier_type = new tree_identifier
		      (yyvsp[0].tok_val->sym_rec (), yyvsp[0].tok_val->line (), yyvsp[0].tok_val->column ());
		  ;
    break;}
case 177:
#line 1040 "parse.y"
{
		    tree_constant *colon =
		      new tree_constant (tree_constant::magic_colon_t);
		    yyval.tree_argument_list_type = new tree_argument_list (colon);
		  ;
    break;}
case 178:
#line 1046 "parse.y"
{ yyval.tree_argument_list_type = new tree_argument_list (yyvsp[0].tree_expression_type); ;
    break;}
case 179:
#line 1048 "parse.y"
{
		    tree_constant *all_va_args =
		      new tree_constant (tree_constant::all_va_args_t);
		    yyval.tree_argument_list_type = new tree_argument_list (all_va_args);
		  ;
    break;}
case 180:
#line 1054 "parse.y"
{
		    tree_constant *colon =
		      new tree_constant (tree_constant::magic_colon_t);
		    yyvsp[-2].tree_argument_list_type->append (colon);
		    yyval.tree_argument_list_type = yyvsp[-2].tree_argument_list_type;
		  ;
    break;}
case 181:
#line 1061 "parse.y"
{
		    yyvsp[-2].tree_argument_list_type->append (yyvsp[0].tree_expression_type);
		    yyval.tree_argument_list_type = yyvsp[-2].tree_argument_list_type;
		  ;
    break;}
case 182:
#line 1066 "parse.y"
{
		    tree_constant *all_va_args =
		      new tree_constant (tree_constant::all_va_args_t);
		    yyvsp[-2].tree_argument_list_type->append (all_va_args);
		    yyval.tree_argument_list_type = yyvsp[-2].tree_argument_list_type;
		  ;
    break;}
case 183:
#line 1075 "parse.y"
{ yyval.tree_expression_type = finish_matrix (yyvsp[-1].tree_matrix_type); ;
    break;}
case 184:
#line 1079 "parse.y"
{ yyval.tree_matrix_type = yyvsp[0].tree_matrix_type; ;
    break;}
case 185:
#line 1081 "parse.y"
{ yyval.tree_matrix_type = yyvsp[-1].tree_matrix_type; ;
    break;}
case 186:
#line 1085 "parse.y"
{ yyval.tree_matrix_type = new tree_matrix (yyvsp[0].tree_matrix_row_type); ;
    break;}
case 187:
#line 1087 "parse.y"
{
		    yyvsp[-2].tree_matrix_type->append (yyvsp[0].tree_matrix_row_type);
		    yyval.tree_matrix_type = yyvsp[-2].tree_matrix_type;
		  ;
    break;}
case 188:
#line 1094 "parse.y"
{ yyval.tree_matrix_row_type = yyvsp[0].tree_matrix_row_type; ;
    break;}
case 189:
#line 1096 "parse.y"
{ yyval.tree_matrix_row_type = yyvsp[-1].tree_matrix_row_type; ;
    break;}
case 190:
#line 1100 "parse.y"
{ yyval.tree_matrix_row_type = new tree_matrix_row (yyvsp[0].tree_expression_type); ;
    break;}
case 191:
#line 1102 "parse.y"
{
		    yyvsp[-2].tree_matrix_row_type->append (yyvsp[0].tree_expression_type);
		    yyval.tree_matrix_row_type = yyvsp[-2].tree_matrix_row_type;
		  ;
    break;}
case 192:
#line 1109 "parse.y"
{ yyval.sep_type = ','; ;
    break;}
case 193:
#line 1111 "parse.y"
{ yyval.sep_type = ';'; ;
    break;}
case 194:
#line 1113 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 195:
#line 1115 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 196:
#line 1119 "parse.y"
{ yyval.sep_type = 0; ;
    break;}
case 197:
#line 1121 "parse.y"
{ yyval.sep_type = yyvsp[0].sep_type; ;
    break;}
case 198:
#line 1125 "parse.y"
{ yyval.sep_type = ','; ;
    break;}
case 199:
#line 1127 "parse.y"
{ yyval.sep_type = ';'; ;
    break;}
case 200:
#line 1129 "parse.y"
{ yyval.sep_type = '\n'; ;
    break;}
case 201:
#line 1131 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 202:
#line 1133 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 203:
#line 1135 "parse.y"
{ yyval.sep_type = yyvsp[-1].sep_type; ;
    break;}
case 204:
#line 1139 "parse.y"
{ yyval.sep_type = 0; ;
    break;}
case 205:
#line 1141 "parse.y"
{ yyval.sep_type = yyvsp[0].sep_type; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/local/share/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 1144 "parse.y"


// Generic error messages.

static void
yyerror (char *s)
{
  int err_col = current_input_column - 1;

  ostrstream output_buf;

  if (reading_fcn_file || reading_script_file)
    output_buf << "parse error near line " << input_line_number
	       << " of file " << curr_fcn_file_full_name;
  else
    output_buf << "parse error:";

  if (s && strcmp (s, "parse error") != 0)
    output_buf << "\n\n  " << s;

  output_buf << "\n\n";

  if (! current_input_line.empty ())
    {
      size_t len = current_input_line.length ();

      if (current_input_line[len-1] == '\n')
        current_input_line.resize (len-1);

// Print the line, maybe with a pointer near the error token.

      output_buf << ">>> " << current_input_line << "\n";

      if (err_col == 0)
	err_col = len;

      for (int i = 0; i < err_col + 3; i++)
	output_buf << " ";

      output_buf << "^";
    }

  output_buf << "\n" << ends;

  char *msg = output_buf.str ();

  parse_error ("%s", msg);

  delete [] msg;
}

// Error mesages for mismatched end tokens.

static void
end_error (char *type, token::end_tok_type ettype, int l, int c)
{
  static char *fmt = "`%s' command matched by `%s' near line %d column %d";

  switch (ettype)
    {
    case token::simple_end:
      error (fmt, type, "end", l, c);
      break;

    case token::for_end:
      error (fmt, type, "endfor", l, c);
      break;

    case token::function_end:
      error (fmt, type, "endfunction", l, c);
      break;

    case token::if_end:
      error (fmt, type, "endif", l, c);
      break;

    case token::while_end:
      error (fmt, type, "endwhile", l, c); 
      break;

    case token::unwind_protect_end:
      error (fmt, type, "end_unwind_protect", l, c); 
      break;

    default:
      panic_impossible ();
      break;
    }
}

// Check to see that end tokens are properly matched.

static int
check_end (token *tok, token::end_tok_type expected)
{
  token::end_tok_type ettype = tok->ettype ();
  if (ettype != expected && ettype != token::simple_end)
    {
      yyerror ("parse error");

      int l = tok->line ();
      int c = tok->column ();

      switch (expected)
	{
	case token::for_end:
	  end_error ("for", ettype, l, c);
	  break;

	case token::function_end:
	  end_error ("function", ettype, l, c);
	  break;

	case token::if_end:
	  end_error ("if", ettype, l, c);
	  break;

	case token::try_catch_end:
	  end_error ("try", ettype, l, c);
	  break;

	case token::unwind_protect_end:
	  end_error ("unwind_protect", ettype, l, c);
	  break;

	case token::while_end:
	  end_error ("while", ettype, l, c);
	  break;

	default:
	  panic_impossible ();
	  break;
	}
      return 1;
    }
  else
    return 0;
}

// Try to figure out early if an expression should become an
// assignment to the built-in variable ans.
//
// Need to make sure that the expression is not already an identifier
// that has a name, or an assignment expression.
//
// Note that an expression can not be just an identifier now -- it
// must at least be an index expression (see the definition of the
// non-terminal variable above).

static tree_expression *
maybe_convert_to_ans_assign (tree_expression *expr)
{
  if (expr->is_index_expression ())
    {
      expr->mark_for_possible_ans_assign ();
      return expr;
    }
  else if (expr->is_assignment_expression ()
	   || expr->is_prefix_expression ())
    {
      return expr;
    }
  else
    {
      // XXX FIXME XXX -- making ans_id static, passing its address to
      // tree_simple_assignment_expression along with a flag to not
      // delete it seems to create a memory leak.  Hmm.

      static symbol_record *sr = global_sym_tab->lookup ("ans", 1, 0);
      tree_identifier *ans_id = new tree_identifier (sr);

      int l = expr->line ();
      int c = expr->column ();

      return new tree_simple_assignment_expression (ans_id, expr, 0, 1, l, c);
    }
}

// Maybe print a warning if an assignment expression is used as the
// test in a logical expression.

static void
maybe_warn_assign_as_truth_value (tree_expression *expr)
{
  if (Vwarn_assign_as_truth_value
      && expr->is_assignment_expression ()
      && expr->is_in_parens () < 2)
    {
      warning ("suggest parenthesis around assignment used as truth value");
    }
}

// Create a plot command.

static tree_plot_command *
make_plot_command (token *tok, plot_limits *range, subplot_list *list)
{
  if (range)
    {
      if (tok->pttype () == token::replot)
	{
	  yyerror ("cannot specify new ranges with replot");
	  return 0;
	}
    }
  else if (! list && tok->pttype () != token::replot)
    {
      yyerror ("must have something to plot");
      return 0;
    }

  lexer_flags.plotting = 0;
  lexer_flags.past_plot_range = 0;
  lexer_flags.in_plot_range = 0;
  lexer_flags.in_plot_using = 0;
  lexer_flags.in_plot_style = 0;
  
  return new tree_plot_command (list, range, tok->pttype ());
}

static tree_expression *
fold (tree_binary_expression *e)
{
  tree_expression *retval = 0;

  tree_expression *op1 = e->lhs ();
  tree_expression *op2 = e->rhs ();

  if (op1->is_constant () && op2->is_constant ())
    {
      octave_value tmp = e->eval (0);

      if (! error_state)
	{
	  tree_constant *tc_retval = new tree_constant (tmp);

	  ostrstream buf;

	  tree_print_code tpc (buf);

	  e->accept (tpc);

	  buf << ends;

	  char *s = buf.str ();

	  tc_retval->stash_original_text (s);

	  delete [] s;

	  delete e;

	  retval = tc_retval;
	}
      else
	delete e;
    }
  else
    retval = e;

  return retval;
}

static tree_expression *
fold (tree_unary_expression *e)
{
  tree_expression *retval = 0;

  tree_expression *op1 = e->operand ();

  if (op1->is_constant ())
    {
      octave_value tmp = e->eval (0);

      if (! error_state)
	{
	  tree_constant *tc_retval = new tree_constant (tmp);

	  ostrstream buf;

	  tree_print_code tpc (buf);

	  e->accept (tpc);

	  buf << ends;

	  char *s = buf.str ();

	  tc_retval->stash_original_text (s);

	  delete [] s;

	  delete e;

	  retval = tc_retval;
	}
      else
	delete e;
    }
  else
    retval = e;

  return retval;
}

// Finish building a range.

static tree_expression *
finish_colon_expression (tree_colon_expression *e)
{
  tree_expression *retval = 0;

  tree_expression *base = e->base ();
  tree_expression *limit = e->limit ();
  tree_expression *incr = e->increment ();

  if (base->is_constant () && limit->is_constant ()
      && (! incr || (incr && incr->is_constant ())))
    {
      octave_value tmp = e->eval (0);

      if (! error_state)
	{
	  tree_constant *tc_retval = new tree_constant (tmp);

	  ostrstream buf;

	  tree_print_code tpc (buf);

	  e->accept (tpc);

	  buf << ends;

	  char *s = buf.str ();

	  tc_retval->stash_original_text (s);

	  delete [] s;

	  delete e;

	  retval = tc_retval;
	}
      else
	delete e;
    }
  else
    retval = e;

  return retval;
}

// Make a constant.

static tree_constant *
make_constant (int op, token *tok_val)
{
  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_constant *retval;

  switch (op)
    {
    case NUM:
      {
	retval = new tree_constant (tok_val->number (), l, c);
	retval->stash_original_text (tok_val->text_rep ());
      }
      break;

    case IMAG_NUM:
      {
	Complex C (0.0, tok_val->number ());
	retval = new tree_constant (C, l, c);
	retval->stash_original_text (tok_val->text_rep ());
      }
      break;

    case TEXT:
      retval = new tree_constant (tok_val->text (), l, c);
      break;

    default:
      panic_impossible ();
      break;
    }

  return retval;
}

// Build a binary expression.

static tree_expression *
make_binary_op (int op, tree_expression *op1, token *tok_val,
		tree_expression *op2)
{
  tree_binary_expression::type t;

  switch (op)
    {
    case POW:
      t = tree_binary_expression::power;
      break;

    case EPOW:
      t = tree_binary_expression::elem_pow;
      break;

    case '+':
      t = tree_binary_expression::add;
      break;

    case '-':
      t = tree_binary_expression::subtract;
      break;

    case '*':
      t = tree_binary_expression::multiply;
      break;

    case '/':
      t = tree_binary_expression::divide;
      break;

    case EMUL:
      t = tree_binary_expression::el_mul;
      break;

    case EDIV:
      t = tree_binary_expression::el_div;
      break;

    case LEFTDIV:
      t = tree_binary_expression::leftdiv;
      break;

    case ELEFTDIV:
      t = tree_binary_expression::el_leftdiv;
      break;

    case EXPR_LT:
      t = tree_binary_expression::cmp_lt;
      break;

    case EXPR_LE:
      t = tree_binary_expression::cmp_le;
      break;

    case EXPR_EQ:
      t = tree_binary_expression::cmp_eq;
      break;

    case EXPR_GE:
      t = tree_binary_expression::cmp_ge;
      break;

    case EXPR_GT:
      t = tree_binary_expression::cmp_gt;
      break;

    case EXPR_NE:
      t = tree_binary_expression::cmp_ne;
      break;

    case EXPR_AND:
      t = tree_binary_expression::and;
      break;

    case EXPR_OR:
      t = tree_binary_expression::or;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_binary_expression *e
    = new tree_binary_expression (op1, op2, l, c, t);

  return fold (e);
}

// Build a boolean expression.

static tree_expression *
make_boolean_op (int op, tree_expression *op1, token *tok_val,
		 tree_expression *op2)
{
  tree_boolean_expression::type t;

  switch (op)
    {
    case EXPR_AND_AND:
      t = tree_boolean_expression::and;
      break;

    case EXPR_OR_OR:
      t = tree_boolean_expression::or;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_boolean_expression *e
    = new tree_boolean_expression (op1, op2, l, c, t);

  return fold (e);
}

// Build a prefix expression.

static tree_expression *
make_prefix_op (int op, tree_identifier *op1, token *tok_val)
{
  tree_prefix_expression::type t;

  switch (op)
    {
    case PLUS_PLUS:
      t = tree_prefix_expression::increment;
      break;

    case MINUS_MINUS:
      t = tree_prefix_expression::decrement;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  return new tree_prefix_expression (op1, l, c, t);
}

// Build a postfix expression.

static tree_expression *
make_postfix_op (int op, tree_identifier *op1, token *tok_val)
{
  tree_postfix_expression::type t;

  switch (op)
    {
    case PLUS_PLUS:
      t = tree_postfix_expression::increment;
      break;

    case MINUS_MINUS:
      t = tree_postfix_expression::decrement;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  return new tree_postfix_expression (op1, l, c, t);
}

// Build a unary expression.

static tree_expression *
make_unary_op (int op, tree_expression *op1, token *tok_val)
{
  tree_unary_expression::type t;

  switch (op)
    {
    case QUOTE:
      t = tree_unary_expression::hermitian;
      break;

    case TRANSPOSE:
      t = tree_unary_expression::transpose;
      break;

    case EXPR_NOT:
      t = tree_unary_expression::not;
      break;

    case '-':
      t = tree_unary_expression::uminus;
      break;

    default:
      panic_impossible ();
      break;
    }

  int l = tok_val->line ();
  int c = tok_val->column ();

  tree_unary_expression *e
    = new tree_unary_expression (op1, l, c, t);

  return fold (e);
}

// Build an unwind-protect command.

static tree_command *
make_unwind_command (token *unwind_tok, tree_statement_list *body,
		     tree_statement_list *cleanup, token *end_tok)
{
  tree_command *retval = 0;

  if (! check_end (end_tok, token::unwind_protect_end))
    {
      int l = unwind_tok->line ();
      int c = unwind_tok->column ();

      retval = new tree_unwind_protect_command (body, cleanup, l, c);
    }

  return retval;
}

// Build a try-catch command.

static tree_command *
make_try_command (token *try_tok, tree_statement_list *body,
		  tree_statement_list *cleanup, token *end_tok)
{
  tree_command *retval = 0;

  if (! check_end (end_tok, token::try_catch_end))
    {
      int l = try_tok->line ();
      int c = try_tok->column ();

      retval = new tree_try_catch_command (body, cleanup, l, c);
    }

  return retval;
}

// Build a while command.

static tree_command *
make_while_command (token *while_tok, tree_expression *expr,
		    tree_statement_list *body, token *end_tok)
{
  tree_command *retval = 0;

  maybe_warn_assign_as_truth_value (expr);

  if (! check_end (end_tok, token::while_end))
    {
      lexer_flags.looping--;

      int l = while_tok->line ();
      int c = while_tok->column ();

      retval = new tree_while_command (expr, body, l, c);
    }

  return retval;
}

// Build a for command.

static tree_command *
make_for_command (token *for_tok, tree_index_expression *var,
		  tree_expression *expr, tree_statement_list *body,
		  token *end_tok)
{
  tree_command *retval = 0;

  if (! check_end (end_tok, token::for_end))
    {
      lexer_flags.looping--;

      int l = for_tok->line ();
      int c = for_tok->column ();

      retval = new tree_for_command (var, expr, body, l, c);
    }

  return retval;
}

// Build a for command a different way.

static tree_command *
make_for_command (token *for_tok, tree_matrix_row *mr,
		  tree_expression *expr, tree_statement_list *body,
		  token *end_tok)
{
  tree_command *retval = 0;

  if (! check_end (end_tok, token::for_end))
    {
      lexer_flags.looping--;

      tree_return_list *id_list = mr->to_return_list ();

      int l = for_tok->line ();
      int c = for_tok->column ();

      retval = new tree_for_command (id_list, expr, body, l, c);
    }

  return retval;
}

// Build a break command.

static tree_command *
make_break_command (token *break_tok)
{
  tree_command *retval = 0;

  int l = break_tok->line ();
  int c = break_tok->column ();

  if (lexer_flags.looping || lexer_flags.defining_func || reading_script_file)
    retval = new tree_break_command (l, c);
  else
    retval = new tree_no_op_command ("break", l, c);

  return retval;
}

// Build a continue command.

static tree_command *
make_continue_command (token *continue_tok)
{
  tree_command *retval = 0;

  int l = continue_tok->line ();
  int c = continue_tok->column ();

  if (lexer_flags.looping)
    retval = new tree_continue_command (l, c);
  else
    retval = new tree_no_op_command ("continue", l, c);

  return retval;
}

// Build a return command.

static tree_command *
make_return_command (token *return_tok)
{
  tree_command *retval = 0;

  int l = return_tok->line ();
  int c = return_tok->column ();

  if (lexer_flags.defining_func || reading_script_file)
    retval = new tree_return_command (l, c);
  else
    retval = new tree_no_op_command ("return", l, c);

  return retval;
}

// Start an if command.

static tree_if_command_list *
start_if_command (tree_expression *expr, tree_statement_list *list)
{
  maybe_warn_assign_as_truth_value (expr);

  tree_if_clause *t = new tree_if_clause (expr, list);

  return new tree_if_command_list (t);
}

// Finish an if command.

static tree_if_command *
finish_if_command (token *if_tok, tree_if_command_list *list,
		   token *end_tok)
{
  tree_if_command *retval = 0;

  if (! check_end (end_tok, token::if_end))
    {
      int l = if_tok->line ();
      int c = if_tok->column ();

      retval = new tree_if_command (list, l, c);
    }

  return retval;
}

// Build an elseif clause.

static tree_if_clause *
make_elseif_clause (tree_expression *expr, tree_statement_list *list)
{
  maybe_warn_assign_as_truth_value (expr);

  return new tree_if_clause (expr, list);
}

// Build an assignment to a variable.

static tree_expression *
make_simple_assignment (tree_index_expression *var, token *eq_tok,
			tree_expression *expr)
{
  int l = eq_tok->line ();
  int c = eq_tok->column ();

  return new tree_simple_assignment_expression (var, expr, 0, 0, l, c);
}

// Make an expression that handles assignment of multiple values.

static tree_expression *
make_multi_val_ret (tree_matrix_row *mr, tree_expression *rhs, token *eq_tok)
{
// Convert the matrix list to a list of identifiers.  If that fails,
// we can abort here, without losing anything -- no other possible
// syntax is valid if we've seen the equals sign as the next token
// after the `]'. 

  tree_expression *retval = 0;

  lexer_flags.maybe_screwed_again--;

  tree_return_list *id_list = mr->to_return_list ();

  if (id_list)
    {
      int list_len = id_list->length ();

      if (list_len == 1)
	{
	  tree_index_expression *lhs = id_list->remove_front ();

	  int l = eq_tok->line ();
	  int c = eq_tok->column ();

	  retval = new tree_simple_assignment_expression (lhs, rhs,
							  0, 0, l, c);
	}
      else if (list_len > 1)
	{
	  if (rhs->is_multi_val_ret_expression ())
	    {
	      tree_multi_val_ret *t = (tree_multi_val_ret *) rhs;

	      int l = eq_tok->line ();
	      int c = eq_tok->column ();

	      retval = new tree_multi_assignment_expression (id_list, t,
							     0, l, c);
	    }
	  else
	    yyerror ("RHS must be an expression that returns multiple values");
	}
      else
	panic_impossible ();
    }
  else
    yyerror ("invalid identifier list for assignment");

  return retval;
}

// Begin defining a function.

static tree_function *
start_function_def (tree_parameter_list *param_list,
		    tree_statement_list *body)
{
  body->mark_as_function_body ();

  tree_function *fcn = new tree_function (body, curr_sym_tab);

  fcn->define_param_list (param_list);

  return fcn;
}

// Do most of the work for defining a function.

static tree_function *
frob_function_def (tree_identifier *id, tree_function *fcn)
{
  string id_name = id->name ();

  // If input is coming from a file, issue a warning if the name of
  // the file does not match the name of the function stated in the
  // file.  Matlab doesn't provide a diagnostic (it ignores the stated
  // name).

  fcn->stash_function_name (id_name);

  if (reading_fcn_file)
    {
      if (curr_fcn_file_name != id_name)
	{
	  if (Vwarn_function_name_clash)
	    warning ("function name `%s' does not agree with function\
 file name `%s'", id_name.c_str (), curr_fcn_file_full_name.c_str ());

	  global_sym_tab->rename (id_name, curr_fcn_file_name);

	  if (error_state)
	    return 0;

	  id_name = id->name ();
	}

      fcn->stash_function_name (id_name);
      fcn->stash_fcn_file_name ();
      fcn->stash_fcn_file_time (time (0));
      fcn->mark_as_system_fcn_file ();
    }
  else if (! (input_from_tmp_history_file || input_from_startup_file)
	   && reading_script_file
	   && curr_fcn_file_name == id_name)
    {
      warning ("function `%s' defined within script file `%s'",
	       id_name.c_str (), curr_fcn_file_full_name.c_str ());
    }

  top_level_sym_tab->clear (id_name);

  id->define (fcn);

  id->document (help_buf);

  return fcn;
}

// Finish defining a function.

static tree_function *
finish_function_def (token *var, tree_function *fcn)
{
  symbol_record *sr = var->sym_rec ();

  int l = var->line ();
  int c = var->column ();

  tree_identifier *tmp = new tree_identifier (sr, l, c);

  tree_parameter_list *tpl = new tree_parameter_list (tmp);

  tpl->mark_as_formal_parameters ();

  return fcn->define_ret_list (tpl);
}

// Finish defining a function a different way.

static tree_function *
finish_function_def (tree_parameter_list *ret_list, tree_function *fcn)
{
  ret_list->mark_as_formal_parameters ();

  return fcn->define_ret_list (ret_list);
}

static tree_index_expression *
make_index_expression (tree_indirect_ref *indir, tree_argument_list *args)
{
  tree_index_expression *retval = 0;

  int l = indir->line ();
  int c = indir->column ();

  if (indir->is_identifier_only ())
    {
      indir->preserve_identifier ();
      retval = new tree_index_expression (indir->ident (), args, l, c);
      delete indir;
    }
  else
    retval =  new tree_index_expression (indir, args, l, c);

  return retval;
}

// Finish building a matrix list.

static tree_expression *
finish_matrix (tree_matrix *m)
{
  tree_expression *retval = 0;

  lexer_flags.maybe_screwed_again--;

  if (m->all_elements_are_constant ())
    {
      octave_value tmp = m->eval (0);

      if (! error_state)
	{
	  tree_constant *tc_retval = new tree_constant (tmp);

	  ostrstream buf;

	  tree_print_code tpc (buf);

	  m->accept (tpc);

	  buf << ends;

	  char *s = buf.str ();

	  tc_retval->stash_original_text (s);

	  delete [] s;

	  delete m;

	  retval = tc_retval;
	}
      else
	delete m;
    }
  else
    retval = m;

  return retval;
}

static void
maybe_warn_missing_semi (tree_statement_list *t)
{
  if (lexer_flags.defining_func && Vwarn_missing_semicolon)
    {
      tree_statement *tmp = t->rear();

      if (tmp->is_expression ())
	warning ("missing semicolon near line %d, column %d in file `%s'",
		 tmp->line (), tmp->column (),
		 curr_fcn_file_full_name.c_str ());
    }
}

static void
set_stmt_print_flag (tree_statement_list *list, char sep,
		     bool warn_missing_semi)
{
  switch (sep)
    {
    case ';':
      {
	tree_statement *tmp = list->rear ();
	tmp->set_print_flag (0);
      }
      break;

    case 0:
    case ',':
    case '\n':
      if (warn_missing_semi)
	maybe_warn_missing_semi (list);
      break;

    default:
      warning ("unrecognized separator type!");
      break;
    }
}

static int
warn_assign_as_truth_value (void)
{
  Vwarn_assign_as_truth_value
    = check_preference ("warn_assign_as_truth_value");

  return 0;
}

static int
warn_comma_in_global_decl (void)
{
  Vwarn_comma_in_global_decl = check_preference ("warn_comma_in_global_decl");

  return 0;
}

static int
warn_function_name_clash (void)
{
  Vwarn_function_name_clash = check_preference ("warn_function_name_clash");

  return 0;
}

static int
warn_missing_semicolon (void)
{
  Vwarn_missing_semicolon = check_preference ("warn_missing_semicolon");

  return 0;
}

void
symbols_of_parse (void)
{
  DEFVAR (warn_assign_as_truth_value, 1.0, 0, warn_assign_as_truth_value,
    "produce warning for assignments used as truth values");

  DEFVAR (warn_comma_in_global_decl, 1.0, 0, warn_comma_in_global_decl,
    "produce warning for commas in global declarations");

  DEFVAR (warn_function_name_clash, 1.0, 0, warn_function_name_clash,
    "produce warning if function name conflicts with file name");

  DEFVAR (warn_missing_semicolon, 0.0, 0, warn_missing_semicolon,
    "produce a warning if a statement in a function file is not
terminated with a semicolon");
}

/*
;;; Local Variables: ***
;;; mode: text ***
;;; End: ***
*/
